• [POJ]P3126 Prime Path[BFS]


    [POJ]P3126

    Prime Path

    Time Limit: 1000MS   Memory Limit: 65536K
    Total Submissions: 35230   Accepted: 18966

    Description

    The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
    — It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
    — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
    — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
    — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
    — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
    — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

    Now, the minister of finance, who had been eavesdropping, intervened. 
    — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
    — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
    — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
    1033
    1733
    3733
    3739
    3779
    8779
    8179
    The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

    Input

    One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

    Output

    One line for each case, either with a number stating the minimal cost or containing the word Impossible.

    Sample Input

    3
    1033 8179
    1373 8017
    1033 1033

    Sample Output

    6
    7
    0

    Source


    两年没写了,现在已经真的菜爆了。
    本题大致意思,给你两个四位的素数,一个是起始状态,另一个是终止状态,要使起始状态变为终止状态每一步可进行的操作为,将这个四位数的某一位更换,但要求新的数也必须是一个素数,问最少步数。
    大致思路也比较简单,就是先欧拉线性筛把所有素数先筛出来,再用在线处理的方式bfs。(然而我bfs写炸了好几次...)
    代码:
    #include<iostream>
    #include<cstdio>
    #include<algorithm>
    #include<cstring>
    using namespace std;
    const int Maxn = 10010 ;
    const int inf = 100000000 ;
    namespace iNx{
        struct qq{
            int num;
            int c;
        };
        qq q[Maxn];
        int primer[Maxn],pos[Maxn];
        bool check[Maxn],exist[Maxn];
        int cnt,best;
        void Euler(){
            memset(check,1,sizeof check);
            int i,j;
            check[1]=false ;
            for(i=2;i<10000;i++){
                if(check[i]) primer[++cnt]=i;
                for(j=1;j<=cnt&&(i*primer[j]<10000);j++){
                    check[i*primer[j]]=false ;
                    if(i%primer[j]==0) break ;
                }
            }
        }
        int getn(int a,int i){
            if(i==1) return a%10;
            if(i==2) return (a/10)%10;
            if(i==3) return (a/100)%10;
            return a/1000;
        }
        void bfs(int a,int b){
            int head=1,tail=1;
            q[1].num=a;
            q[1].c=0;
            int i,j,h,k,m,t;
            while(tail>=head){
                h=q[head].num;
                if(h==b){
                    printf("%d
    ",q[head].c);
                    break ;
                }
                exist[h]=true ;
                for(i=1;i<=4;i++){
                    k=getn(h,i);
                    for(j=1,m=1;j<i;j++) m*=10;
                    for(j=0;j<=9;j++){
                        if(i==4&&j==0) continue ;
                        if(j==k) continue ;
                        t=h+j*m-k*m;
                        if(check[t]&&(!exist[t])){
                            q[++tail].num=t;
                            q[tail].c=q[head].c+1;
                        }
                    }
                }
                head++;
            }
        }
        int main(){
            Euler();
            int n,a,b,i;
            scanf("%d",&n);
            for(i=1;i<=n;i++){
                scanf("%d%d",&a,&b);
                memset(exist,0,sizeof exist);
                bfs(a,b);
            }
            return 0;
        }
    }
    int main(){
        iNx::main();
        return 0;
    }

    现在要开始天天练习了,蒟蒻我太难了。

  • 相关阅读:
    Coursera课程《Python数据结构》中课件
    Coursera课程《Python数据结构》中课程目录
    Coursera课程《大家的编程》(Python入门)中课程目录
    Python for everyone chapter 1
    Coursera课程《大家的python》(Python for everyone)课件
    Coursera课程《大家的Python》中一些资料
    局部敏感哈希 Kernelized Locality-Sensitive Hashing Page
    CVPR14 图像检索papers
    Sequential projection learning for hashing阅读笔记
    Hashing图像检索源码及数据库总结
  • 原文地址:https://www.cnblogs.com/_inx/p/11478805.html
Copyright © 2020-2023  润新知